<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
<!--      <el-form-item label="证书名称" prop="certificateName">-->
<!--        <el-input v-model="formData.certificateName" placeholder="请输入证书名称" />-->
<!--      </el-form-item>-->
      <el-form-item label="证书类型" prop="probation">
        <el-select v-model="formData.certificateType" placeholder="请选择证书类型">
          <el-option
            v-for="dict in getDictOptions(DICT_TYPE.HR_CERTIFICATE_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="有效期" prop="dateRange">

        <el-date-picker
          v-model="formData.dateRange"
          type="daterange"
          value-format="x"
          range-separator="至"
          start-placeholder="选择开始时间"
          end-placeholder="选择结束时间"
        />
      </el-form-item>
      <el-form-item label="证书附件" prop="certificateFile">
        <UploadFile v-model="formData.certificateFile" :limit="1"/>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { EmployeeCertificateApi, EmployeeCertificate } from '@/api/hr/employeecertificate'
import {DICT_TYPE, getDictOptions} from "@/utils/dict";

/** 员工证书 表单 */
defineOptions({ name: 'EmployeeCertificateForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  employeeId: undefined,
  dateRange: [],
  certificateName: undefined,
  certificateType: undefined,
  startTime: undefined,
  endTime: undefined,
  certificateFile: undefined,
})
const formRules = reactive({
  certificateType: [{ required: true, message: '合同类型不能为空', trigger: 'blur' }],
  dateRange: [{ required: true, message: '有效期不能为空', trigger: 'blur' }],
  certificateFile: [{ required: true, message: '附件不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  formData.value.employeeId  = id;
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EmployeeCertificate
    if (formType.value === 'create') {
      data.startTime = data.dateRange[0];
      data.endTime = data.dateRange[1];
      await EmployeeCertificateApi.createEmployeeCertificate(data)
      message.success(t('common.createSuccess'))
    } else {
      await EmployeeCertificateApi.updateEmployeeCertificate(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    employeeId: undefined,
    certificateName: undefined,
    certificateType: undefined,
    stratTime: undefined,
    endTime: undefined,
    certificateFile: undefined,
  }
  formRef.value?.resetFields()
}
</script>
